(page 
  :extra-head '(link (:rel "preload" :as "image" :href "/assets/bg.svg"))
  :description "natalie[ee]'s website"
  `((section
    (h1 (:title "the dot in natalieee dot net stands for department of transportation") "natalieee dot net")
    ("another website it owns.")
    (p "this is the personal website of natalie[ee] (roentgen connolly).")
    (p "recently, it has chosen to rewrite its entire website, " 
      "including the static site generator and the http server. as such, there will be discontinuities with the prior iteration of the site. "
      "the historically minded are encouraged to look at the archive.org page for this website prior to early may 2025.")
    
    (p "if $READER is confused, interested or any adjective, frankly about information found herein, they are encouraged to e-mail natalie. its contact information may be found on " ~(link "/html/about-natalie.html") " or below."))

  (section
    (h2 "site info" ~(run "make-footnote \"as of last build\""))
    (details
      (summary "git changelog")
      (pre ~(run "git log --pretty=format:'%ad %s' --date=short")))
      
    (details
      (summary "file tree of the site on the server")
      (pre ~(run "tree . | sed 's/^\\./site/; s/─/-/g; s/├/|/g; s/└/\\\\/g; s/│/|/g'")))
    ~(run "put-footnotes"))

  (section
    (h2 "88x31s")
    "its 88x31 may be placed on other websites with the following html:"
    (code ~(run "syntax-hl data/88x31.html"))
    (div (:class 88x31-buttons)
      ~(do
        (import yaml [safe-load])
        
        (with [f (open "data/88x31s.yaml" "r")]
          (setv 88x31s (safe-load f)))

        (.join "" (lfor form [
          `(p (:style "margin-bottom: 4px;") "entities or organizations:")
          #* (lfor button (get 88x31s "specific")
            (cond
              (and (in "host" button) (in "src" button) (in "alt" button))
                `(a (:href ~(get button "host") :target "_blank") 
                  (img (:src ~(get button "src") :alt ~(get button "alt"))))
              True ""))
          `(p (:style "margin-bottom: 4px") "arbitrary:")
          #* (lfor button (get 88x31s "general")
            (cond 
              (or (in "src" button) (in "alt" button))
                `(img (:src ~(get button "src") :alt ~(get button "alt")))
              True ""))
            ] (form->html form)))))
      
      (p "the reader may request their button be displayed here by e-mailing their domain, button, and alt-text for the button to the following e-mail: "
      (a (:href "mailto:natalieee.net+88x31@8.f.9.e.0.7.4.0.1.0.0.2.ip6.arpa") "natalieee.net+88x31@8.f.9.e.0.7.4.0.1.0.0.2.ip6.arpa")))
  
  ~(comments "/")))
