(page 
  :extra-head '(link (:rel preload :as image :href "/assets/bg.svg"))
  :title "natalie info"
  :description "information about natalie of natalieee.net"
  `(
    (section
      (h1 "what is a natalie?")
      "it is " ~(link "/html/natalie-sightings.html" "natalie") ~(run "make-footnote 'the natalie is provided \"as is\", without warranty of any kind, express or implied, including but not limited to the warranties of merchantability, fitness for a particular purpose, title and non-infringement. in no event shall the copyright holders or anyone distributing the natalie be liable for any damages or other liability, whether in contract, tort or otherwise, arising from, out of or in connection with the natalie or the use or other dealings in the natalie.'") ". obviously"
      
      (p "it is bad at writing. it is especially bad at writing about itself. in spite of these shortcomings, it will attempt an adequate self description. "))
    
    (section
      (h2 "natalie, summarized")
      "Accept-Pronouns: it/its;q=1.0, she/her;q=0.8, they/them;q=0.1" (br)
      "Accept-Language: en-US;q=1.0" (br)
      "Location: Portland OR" (br)
      "Age: $[echo $(( $(date +%s) - $(date -d \"2007-04-01\" +%s) ))]; years=$[echo \"scale=8; ($(date +%s) - $(date -d '2007-04-01' +%s)) / (365.25*24*3600)\" | bc]" (br)
      "X-Neurodiversity: autism;p=1.0, adhd;p=0.9" (br)
      "X-Gender-Identity: agender transfem" (br)
      "X-Sexuality: non-practicing asexual"

      (p "natalie has many properties. among these properties is the fact that it is a college student. it really does not want to be a college student, however it doubts it will find employment "
        "it deems satisfying if it is not a college student for a frankly unnecessary and inconvenient amount of time." ~(run "make-footnote 'on the off-chance that it appears to be the correct flavor of strange to be employed by the reader in some field relating to computers, please please please e-mail it.'"))
      
      (p "another notable property it possesses is speaking and thinking in the third person&mdash;as this site is written. generally, it thinks it is neat when others address it this way&mdash;though it is not particularly opinionated. it is not sure why it thinks this way, and its doing so varies depending on its mood, environment, and current social context.")
      
      (p "some entities have informed it that it writes \"pretentiously\". this is, unfortunately, reasonably likely to be correct (though it isn't sure?). it writes words in a similar order to that which it thinks them in, so at least it is sincere in its pretentious(?) writing style. "
        "many an english teacher have accused it of using generative ai. it really is not sure why they have done this, as it writes in an actually robotic tone (not a \"badly pretending to be someone with a business degree\" tone), but it would guess it is the autism. perhaps it could also be the fact that it is fond of em-dashes?")
      
      (p "it did not graduate from high school. instead it dropped out, took the GED, and started going to college. it got bored of high school because it took all of the advanced-placement science and math classes available to it, and thus failed many of its more mundane classes. "
        "it finds that its ability to do work is generally contingent upon being given interesting or challenging work to do. high school did not provide this outside of advanced-placement classes. college has yet to provide this. it is disappointed, and fearful for its grades."))
    
    (section
      (h2 "hobbies, likes and dislikes, opinions")
      (h3 hobbies)
      (p "it has several hobbies. all of them relate to manipulating systems bound by complex rules in interesting ways.")
      (ul
        (li "configuring software to an unreasonably personal extent")
        (li "writing its own software, often in unconventional ways, to solve problems unique to natalie")
        (li "making websites with non-existent tech stacks (hy, bash, hy)")
        (li "writing awful, noncompliant http servers to support the above hobby")
        (li "creating awful bash oneliners")
        (li "modifying its build of the linux kernel")
        (li "making the python interpreter segfault" ~(run "make-footnote 'there are some relevant blog posts about this one.'")))
      
      (p "additionally, it enjoys learning about math, chemistry, biology, physics, geography, urban planning, history, and languistics. "
        "it has an interest in locks as well, and will make keys when it is bored. sometimes they are even keys it is allowed to have." ~(run "make-footnote \"it will not make keys for things it shouldn&apos;t when asked nicely not to, or when it senses that it would get in annoying amounts of trouble for doing so\""))
      (br)
      
      (h3 "likes and dislikes")
      (p "trunkated unordered enumeration of things it likes:")
      (ul 
        (li "its computer")
        (li "friends")
        (li "walking around cities aimlessly and looking at cool infrastructure")
        (li "trains")
        (li "interesting problems")
        (li "croissants"))
      
      (p "trunkated unordered enumeration of things it does not like:")
      (ul
        (li "computers that do not share a keyboard layout with its computer")
        (li "american urban planning")
        (li "canadian urban planning")
        (li "the united kingdom")
        (li "xml")
        (li "toml")
        (li "busywork")
        (li "computers")
        (li "ultraviolet radiation")
        (li "institutions that purport themselves to be academic in nature but actively hinder its learning")
        (li (span (:style "color: var(--light-gray)") "&lt;joke&gt;") "non-croissant french cultural exports" (span (:style "color: var(--light-gray)") "&lt;/joke&gt;")))
      
      (h3 "opinions")
      (p "all of these are objectively true, endorsed by <i>your</i> employer, $[(echo the catholic church, and the king of spain.; echo 9 out of 10 dentists, and a majority of the united states supreme court.;) | shuf -n1]")
      (ul (:style "margin-bottom: 0")
        (li "the modern web is a perversion of the original intent of the internet (thanks, <del>obama</del> capitalism).")
        (li "modern web development is evil, and the evilness of it is only diminished when your tech stack involves htmx for the front-end and absolutely 0 javascript on the back-end.")
        (li "(generative) ai, (generative) ai companies, and especially (generative) ai company owners should all shut up and preferably stop existing.")
        (li "there is and never has been a good unix terminal emulator." ~(run "make-footnote 'if the reader disagrees, e-mail this one with the reader&apos;s choice of terminal emulator&mdash;this one has been trying to find a good one for ages.'"))
        (li "there is and never has been a good wayland compositor")
        (li "there is and never has been a good xorg window manager (fvwm comes close, though)")
        (li "the gtk developer experience is frustrating")
        (li "brodie robertson has an obnoxious face")
        (li "no good smart phones manufactured after 2016 exist.")
        (li "non-posix-compliant shells are annoying.")
        (li "file managers, especially graphical ones, are worse than useless.")
        (li "word processing software is arcane and incomprehensible, and there are few cases where it is not easier to use " (span ~(run "echo -e $(cat data/latex-logo.mathml)")))))
    
    (section
      (h2 "technical specifications")
      (h3 () "anthropromorphic measurements")
      (div (:style "display: grid; grid-template-columns: 1fr 1fr")
        (div "height:")
        (div "172.72cm")
        (div "bideltoid:")
        (div "41.30cm")
        (div "shoulder circumference:")
        (div "92.44cm")
        (div "waist circumference:")
        (div "54.15cm - 61.69cm")
        (div "hip circumference")
        (div "88.39cm")
        (div "underbust circumference:")
        (div "66.31cm")
        (div "bust circumference:")
        (div "75.86cm")
        (div "inseam:")
        (div "79.45cm"))
      
      (br)
      (h3 () "favorite color")
      (span (:style "color: teal") "teal"))

    (section
      (h2 "contact")
      (p "modes of communication ordered by likelihood of it seeing the reader's message:"
      (ol
        (li "e-mail (note: it is equally likely to perceive messages to any of thtese addresses):" (ul
          (li "natalie at natalieee.net")
          (li "natalie-roentgen-connolly at mail.natalie-roentgen-connolly.website"
          (li "natalie at 8.f.9.e.0.7.4.0.1.0.0.2.ip6.arpa"
          (li "natalie at 1.b.1.0.b.0.0.0.0.7.4.0.1.0.0.2.ip6.arpa")))))
        (li "fedi: " ~(link "//mastodon.catgirl.cloud/@0x6e6174" "@0x6e6174@catgirl.cloud"))
        (li "discord: @0x6e6174")
        (li "matrix: @0x6e6174:catgirl.cloud"))))
    
    (section
      (h2 "cryptography")
      (blockquote () "ssh:" (br) "ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIOs2VLWgMxmQlLFSpOG01v6i5pVLtgHyQg74nwNNYTlT natalie@natalieee.net") (br)
      (blockquote () "pgp:" (br) (pre ~(run "cat data/pubkey.asc"))) (br))
    
    (section
      (h2 "computers it owns")
      (p "it owns many computers. here are some notable ones:")
      (ul
        (li ~(link "/html/its-laptop.html" "its framework 16"))
        ;; (li ~(link "/html/its-old-laptop.html" "its old {w,t}530"))
        ;; (li ~(link "/html/this-server.html" "the server this site runs on"))
        ))
    
    ~(run "put-footnotes")
    ~(comments "/htm/about-natalie.html"))))
