(page 
  :extra-head '(link (:rel preload :as image :href "/assets/bg.svg"))
  :title "site info"
  :description "information about natalieee.net"
  `(
    (section
      (h1 "site info")
      (p "it was displeased with its previous state of not having a website, and thus chose to remedy this. "
        "now it has a place to put all of its silly little thoughts." ~(run f"make-footnote \"see also: {(form->html (link "https://mastodon.catgirl.cloud/@0x6e6174" "its fedi"))}\"")
        "in addition to the aforementioned purpose, this site also exists because: ")
        (ul
          (li "having a website is an abnormally good means of self expression" ~(run "make-footnote \"in its opinion\""))
          (li "remembering the IP address" ~(run "make-footnote \"which changes not infrequently\"") " of its server is annoying")
          (li "it wanted a domain such that its name was a substring of that domain"
          (li "having a website is congruent with its interests"
          (li "it enjoys creating and maintaining reasonably complex systems")))))

    (section
      (h2 "webocodynamics of natalieee.net")
      (p "natalieee.net has a few subdomains, these should be enumerated. additionally, there are a few other domains through which this site is accessible.")
      (br)
      (h3 "subdomains of natalieee.net:")
      (dl 
        (dt "git.natalieee.net")
        (dd "its personal gitea instance. should probably be migrated to forjo. a few others have accounts there.")
        (dt "files.natalieee.net")
        (dd "its (bad) fileserver. functionally just a hack to make arbitrary files accessible over http"))

      (h3 "other domains through which this site is accessible")
      (ul (:style "margin-bottom: 0")
        (li ~(link "http://natalieee.net.8.f.9.e.0.7.4.0.1.0.0.2.ip6.arpa"))
        (li ~(link "http://natalieee.net.1.b.1.0.b.0.0.0.0.7.4.0.1.0.0.2.ip6.arpa")))
      (br)
      
      (h3 "static site generator")
      (p "this site uses a custom-build static site generator written in " ~(link "https://hylang.org" "hy") ". "
        "the design of this static site generator is rather unique: it compiles quoted hy" ~(run "make-footnote \"which is a lisp\"") " forms to html such that the structure of a quoted hy form is the structure of the output html. "
        "this allows it to do useful things like placing unquoted code inside of quoted documents, functionally creating a macro system where it can run arbitrary code at website generation time. ")
      (p
        "most of the time&mdash;such as with the comment section at the bottom of pages&mdash;this ability is used not for running hy code, but instead for invoking shell scripts that output html, however there are a few instances of hy code being envoked on its own. "
        "an example of hy code being envoked on its own would be the part of the home page where 88x31s are displayed. that is generated at compile time by parsing a yaml file that specifies the src, href, alt, and optionally title property of each 88x31.")
      (br)
      
      (b "static site generator example:")
      (div (:class two-col-table)
        (figure (figcaption "input")
         (code ~(run "syntax-hl data/ssg-example.hy")))
        (figure (figcaption "output")
         (code ~(run "syntax-hl data/ssg-example.html"))))

      (p "this design is very nice, because this way it does not have to write closing tags. "
        "the experience of writing lisp is much less cumbersome than the experience of writing xml-like syntax&mdash;at least without doing an unpleasant amount of vim configuring. "
        "the means of running code at compile time is also much nicer than any templating system it has found, as it is as simple as unquoting a lisp form. "
        "also, it allows for templating, as this one can just write functions that go inside of quoted forms that return more quoted forms when called.")
     
      (br) 
      (h3 "http server")
      (p "the web server is pretty unremarkable in most ways. "
        "it is more or less what anyone would write if they were instructed to write an http server in hy. "
        "it does, however, have one unique feature: upon a page being requested, all instances of $[echo '00000000: 245b 5d0a' | xxd -r] on that page are interpreted as bash code, and replaced with the result of executing said bash code.")
      
      (p "this allows for compiled pages to be rendered with up-to-date information at page request time. it also allows arbitrary scripts to be run at request time. "
        "this is very helpful, because it means that it does not need to use demon technologies like javascript to achieve such things as the comments function or the \"page rendered at\" time in the footer")
     (br)

      "further example of the static site generator:"
      (figure
        (figcaption "the template that gets called to create the comments below:")
        (code ~(run "syntax-hl templates/comments.hy | sed -e 's/\\[/\\&#91;/g' -e 's/\\]/\\&#93;/g'")))
      (p "this code gets executed at compile time, however the compiled output contains the $&#91;&#93; string, and thus that part gets executed at page serve time such that comments are update every page load instead of only at compile time."))

    ~(run "put-footnotes")
    ~(comments "/html/site-info.html")))

