(import html [escape])
(import itertools [batched])
(import subprocess [run :as subprocess/run PIPE])
(import os [environ :as hy-env])

(require hyrule.destructure [setv+])

(setv self-closing-tags ['area 'base 'br 'col 'embed 'hr 'img 'input 'link 'meta 'param 'source 'track 'wbr])

(defn run [command]
  (setv env hy-env)
  (setv (get env "PATH") (+ (get hy-env "PATH") ":./scripts"))
  (.decode (getattr (subprocess/run command :env env :shell True :stdout PIPE :stderr None) "stdout")))

(defn form->html [html]
  (when (is html None) 
    (return ""))

  (cond
    (isinstance html str) (str html)
    (or (isinstance html int) (isinstance html float)) (str html)
    (isinstance html hy.models.Expression) 
      (cond
        (not (isinstance (get html 0) hy.models.Symbol)) 
          (.join "" (map form->html html))

        True
          (do 
            (setv+ [tag attrs :& rest] html)
            (when (is attrs None) (setv attrs []))

            (when (len attrs)
              (when (not (isinstance (get attrs 0) hy.models.Keyword))
                (do
                  (setv rest (+ [attrs] rest))
                  (setv attrs []))))

            (when (not (isinstance tag hy.models.Symbol))
              (return ""))

            (.format "<{}{}>{}{}"
              (.lower tag)
              (+ (if (len attrs) " " "") (.join " " (lfor [k v] (batched attrs :n 2) 
                f"{(cut (str k) 1 None)}=\"{v}\"")))
              (.join "" (map form->html rest))
              (if (not-in tag self-closing-tags) 
                f"</{(.lower tag)}>" 
                ""))))))
